#!/bin/sh
#
####################################################
#
#   CheckPing ver 0.4 (c) 2002 cal6@spam.ee
#
#==================================================
#
#  Requirements:
#  =============
#  - bash ;-)
#  - crontab
#  - MySQL 3.23.32+
#  - PHP with GD 1.2 libaries (for gif generation)
#  - writable directory
#
#  Installation:
#  =============
#  - change this file to reflect your system
#  - change connect.php to reflect your system
#  - change iplist.txt to reflect systems you want to ping
#  - put in your crontab row: */2 * * * * /path/to/checkping.sh >/dev/null 2>/dev/null
#  - create table to your database:
#
#  CREATE TABLE PingPong (
#    Added datetime default NULL,
#    Status enum('1','2') default NULL,
#    Timeout varchar(20) default NULL,
#    IP varchar(20) NOT NULL default '',
#    KEY IP (IP)
#  ) TYPE=MyISAM;
#
####################################################

HOMEDIR='/path/to/checkping-0.4'
PINGLOC='/bin/ping'
SEDLOC='/bin/sed'
GREPLOC='/bin/grep'
SENDMAILLOC='/usr/sbin/sendmail'
MYSQLLOC='/usr/bin/mysql'
DBHOST='localhost'
DBUSER='root'
DBPASS='mysecretpass'
DBNAME='checkping'
ERRORMAIL='cal6@spam.ee'


####################################################
#
#   Do not change past this point
#
####################################################


IP_LIST=`cat $HOMEDIR/iplist.txt`

for IP in $IP_LIST ; do

	PING_RES=`$PINGLOC -c 1 $IP | $GREPLOC seq | $SEDLOC s/.*=//g | $SEDLOC s/\ .*//g`

	if [ -z "$PING_RES" ] ; then
		$MYSQLLOC -h $DBHOST -u $DBUSER -p$DBPASS -e "INSERT INTO PingPong (Added, Status, IP) VALUES (NOW(), '1', '$IP');" $DBNAME
		echo "timeout" >> $HOMEDIR/checkping.$IP.txt
		PING_COUNT=`/bin/grep timeout -c $HOMEDIR/checkping.$IP.txt`
		if [ $PING_COUNT -eq 5 ] ; then
			echo "network downtime over 10 minutes ($IP)" | $SENDMAILLOC -f$ERRORMAIL $ERRORMAIL
		fi
	else
		$MYSQLLOC -h $DBHOST -u $DBUSER -p$DBPASS -e "INSERT INTO PingPong (Added, Status, Timeout, IP) VALUES (NOW(), '2', '$PING_RES', '$IP');" $DBNAME
		echo "" > $HOMEDIR/checkping.$IP.txt
	fi
done
